require "numru/ggraph"
include NumRu

a_ncfn = [
  'out/Earth_ICRCCM_LW_Case25_TRP_CO2-300ppmv.nc',
  'out/Earth_ICRCCM_LW_Case26_TRP_CO2-600ppmv.nc',
  'out/Earth_ICRCCM_LW_Case27_MLS_CO2-300ppmv.nc',
  'out/Earth_ICRCCM_LW_Case28_MLS_CO2-600ppmv.nc',
  'out/Earth_ICRCCM_LW_Case29_MLW_CO2-300ppmv.nc',
  'out/Earth_ICRCCM_LW_Case30_MLW_CO2-600ppmv.nc',
  'out/Earth_ICRCCM_LW_Case31_SAS_CO2-300ppmv.nc',
  'out/Earth_ICRCCM_LW_Case32_SAS_CO2-600ppmv.nc',
  'out/Earth_ICRCCM_LW_Case33_SAW_CO2-300ppmv.nc',
  'out/Earth_ICRCCM_LW_Case34_SAW_CO2-600ppmv.nc',
]
vname = "Temp"

iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

#DCL.sldiv('y',1,4)
#DCL.sgpset('isub', 96)     # control character of subscription: '_' --> '`'
DCL.sglset('LCNTL', true)
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)            # font size
DCL.sgpset('lclip', true)  # clip graph
#DCL.udlset('LMSG', false)  # flag for message of contour interval
DCL.glpset('lmiss',true)   # missing value

#DCL.sgscmn(4)  # blue-cyan-white-yellow-red
#DCL.sgscmn(5)  # gray-scale
#DCL.sgscmn(14) # blue-white-red

#levels = [110,120,130,140,150,160,170,180,190,200,210,220,230,240]
#patterns = [10999,15999,20999,25999,30999,35999,40999,50999,60999,65999,70999,75999,80999,90999,95999]

GGraph.set_fig 'itr'=> 2, 'viewport'=>[0.1,0.9,0.1,0.65], 'window'=>[175,325,1.1e5,1.0e-2]

flag_first = true
a_ncfn.each_with_index { |ncfn,i|
  url = ncfn + "@" + vname
  gphys = GPhys::IO.open_gturl( url )
  GGraph.line gphys, flag_first, 'exchange'=>true, 'index'=>(i+1)*10+1
  flag_first = false
}

ncfn = a_ncfn[3-1]
url = ncfn + "@" + vname
gphys = GPhys::IO.open_gturl( url )
gphys += 25
GGraph.line gphys, flag_first, 'exchange'=>true, 'type'=>2,
            'legend_vx'=>0.7, 'legend'=>'MLS+25 K'
gphys -= 50
GGraph.line gphys, flag_first, 'exchange'=>true, 'type'=>2,
            'legend_vx'=>0.7, 'legend'=>'MLS-25 K'

DCL.grcls
