#!/usr/bin/ruby

nprocs = 32

symbols = [
  'Earth_ICRCCM_LW_Case25_TRP_CO2-300ppmv',
  'Earth_ICRCCM_LW_Case26_TRP_CO2-600ppmv',
  'Earth_ICRCCM_LW_Case27_MLS_CO2-300ppmv',
  'Earth_ICRCCM_LW_Case28_MLS_CO2-600ppmv',
  'Earth_ICRCCM_LW_Case29_MLW_CO2-300ppmv',
  'Earth_ICRCCM_LW_Case30_MLW_CO2-600ppmv',
  'Earth_ICRCCM_LW_Case31_SAS_CO2-300ppmv',
  'Earth_ICRCCM_LW_Case32_SAS_CO2-600ppmv',
  'Earth_ICRCCM_LW_Case33_SAW_CO2-300ppmv',
  'Earth_ICRCCM_LW_Case34_SAW_CO2-600ppmv',
]

conf_calc_ac_file          = 'calc_ac_file.conf'
template_conf_calc_ac_file = 'template_' + conf_calc_ac_file
conf_merge                 = 'merge.conf'
template_conf_merge        = 'template_' + conf_merge

for iloop in 0..(symbols.size-1)
  sym = symbols[iloop  ]
  print "\n"
  print '---------------------------------------------------', "\n"
  print 'Loop for symbols #', iloop, ' : ', sym, "\n"
  print "\n"

  line = 'cat '+template_conf_calc_ac_file+
         '| sed -e s#SYMBOL#'+sym+'#g'+
         '> '+conf_calc_ac_file
  p line
  system(line)

  line = 'mpiexec -n '+nprocs.to_s+' ../calc_ac'
  p line
  system(line)

  line = 'cat '+template_conf_merge+
         '| sed -e s#SYMBOL#'+sym+'#g'+
         '| sed -e s#NPROCS#'+nprocs.to_s+'#g'+
         '> '+conf_merge
  p line
  system(line)

  line = '../merge'
  p line
  system(line)

end

