program main_ac_process

  use vtype_module

  use fi_module

  use ac_process_module, only : ac_process

  implicit none


  character(extstr)       :: CtlFN  = 'ac_process.conf'

  integer                 :: iostat
  integer                 :: FileUnit

  character(len=4*extstr) :: InputFileName1
  character(len=4*extstr) :: InputFileName2
  character(len=4*extstr) :: OutputFileName

  real(dp)                :: Factor1
  real(dp)                :: Factor2


  namelist /factor_nml/ &
    & Factor1, Factor2
  namelist /file_nml/ &
    & InputFileName1, InputFileName2, OutputFileName


  Factor1        = 0.0d0
  Factor2        = 0.0d0
  InputFileName1 = ''
  InputFileName2 = ''
  OutputFileName = ''

  ! Read a namelist file

  call fi_open( CtlFN, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = factor_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist in factor_nml is something wrong.'
  end if
  write( 6, nml = factor_nml )
  !
  rewind( FileUnit )
  read( FileUnit, nml = file_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist in file_nml is something wrong.'
  end if
  write( 6, nml = file_nml )
  !
  close( FileUnit )


  call ac_process(                              &
    & InputFileName1, InputFileName2, OutputFileName, &
    & Factor1, Factor2                                &
    & )


  write( 6, * ) 'Finish'
end program main_ac_process
