set key left Left reverse

unset logscale

set xlabel  "loop #"
set ylabel  "RMSEs with respect to k-dist. model"
set y2label "RMSEs with respect to LBL model"
set ytics nomirror
set y2tics nomirror

plot \
     "out/loss.txt"u 1:2 t "sum" w lp, \
     "out/loss.txt"u 1:4 t "UR.upflx" w lp, \
     "out/loss.txt"u 1:5 t "SR.upflx" w lp, \
     "out/loss.txt"u 1:6 t "PR.dnflx" w lp, \
     "out/loss.txt"u 1:7 t "SR.dnflx" w lp, \
     "out/loss_lbl.txt"u 1:2 axes x1y2 t "sum (LBL)" w lp lw 3

pause -1

set logscale y

set xlabel  "# of IPs"
set ylabel  "RMSEs with respect to k-dist. model"
set y2label ""
set ytics mirror

plot \
     "../dir_optimize_descend_ref-kdist_update3/out/loss.txt"u (21*2*8-($1+1)*2):2 t "decrease IP in a band once" w l, \
     "../dir_optimize_descend_ref-kdist_update3_subreg/out/loss.txt"u (21*2*8-($1+1)):2 t "decrease IP in each sub-region (old)" w l, \
     "out/loss.txt"u (21*2*8-$1):2 t "decrease IP in each sub-region" w l lt 4


