#!/usr/bin/bash

export LC_ALL=C

datafile='zzz.data'

# check the start date and time of calculation
#   check PID of program
pid=`fuser error.log 2> /dev/null`
#   read date and time of start
cmon=`ps -eo lstart,user,pid,cmd | grep ${pid} | grep -v grep | awk '{print $2}'`
day=`ps -eo lstart,user,pid,cmd | grep ${pid} | grep -v grep | awk '{print $3}'`
hhmmss=`ps -eo lstart,user,pid,cmd | grep ${pid} | grep -v grep | awk '{print $4}'`
mon=`date -d"${cmon} ${day}" +%m`  # convert character of month name to number
hhmm=${hhmmss%:*}                  # delete second
echo ${mon}-${day}-${hhmm} 0 > ${datafile}

# check time stamp of result files
ls -ltr --time-style=iso out | grep -v total | awk '{print $6"-"$7" "NR}' >> ${datafile}

# draw a figure
gnuplot "util_chktimestamp_v2_plot.gp"
