#!/usr/bin/ruby

# NOTE:
#   You have to change

ncfn_ref_flux = "../lbl_dwn00.01e2/prog03.0_calc_rte/out/Earth_ICRCCM_LW_Case27_MLS_CO2-300ppmv_Flux.nc"
ncfn_ref_tend = "../lbl_dwn00.01e2/prog03.0_calc_rte/out/Earth_ICRCCM_LW_Case27_MLS_CO2-300ppmv_Tendency.nc"

a_ncfn_list = [
  # LBL 0.01 cm-1  vs  LBL 0.01 cm-1 shift
  "../lbl_dwn00.01e2_shift/prog03.0_calc_rte/out/Earth_ICRCCM_LW_Case27_MLS_CO2-300ppmv_Flux.nc",
  "../lbl_dwn00.01e2_shift/prog03.0_calc_rte/out/Earth_ICRCCM_LW_Case27_MLS_CO2-300ppmv_Tendency.nc",
  # LBL 0.01 cm-1  vs  LBL 0.2 cm-1 & 2 cm-1
  "../lbl_dwn00.2e2+02.0e2/prog03.0_calc_rte/out/Earth_ICRCCM_LW_Case27_MLS_CO2-300ppmv_Flux.nc",
  "../lbl_dwn00.2e2+02.0e2/prog03.0_calc_rte/out/Earth_ICRCCM_LW_Case27_MLS_CO2-300ppmv_Tendency.nc",
  # LBL 0.01 cm-1  vs  KD 82 bands & 1312 IPs without interpolation
  "../k-dist_fixvmr_dwn00.2e2+02.0e2/prog04.0_sort_ac_check/out.practice/Flux-000-10.nc",
  "../k-dist_fixvmr_dwn00.2e2+02.0e2/prog04.0_sort_ac_check/out.practice/Tendency-000-10.nc",
  # LBL 0.01 cm-1  vs  KD 25 bands & 121 IPs without interpolation
  "../k-dist_fixvmr_dwn00.2e2+02.0e2/prog04.0_sort_ac_check/out/Flux-000-10.nc",
  "../k-dist_fixvmr_dwn00.2e2+02.0e2/prog04.0_sort_ac_check/out/Tendency-000-10.nc",
  # LBL 0.01 cm-1  vs  KD 82 bands & 121 IPs with interpolation
  "../k-dist_fixvmr_dwn00.2e2+02.0e2/prog08.0v2_calc_rte_check/out/Earth_ICRCCM_LW_Case27_MLS_CO2-300ppmv_Flux.nc",
  "../k-dist_fixvmr_dwn00.2e2+02.0e2/prog08.0v2_calc_rte_check/out/Earth_ICRCCM_LW_Case27_MLS_CO2-300ppmv_Tendency.nc",
]

rmse_script          = 'disp_comp_1Dresults_v1mod.rb'
rmse_script_template = 'template_'+rmse_script


a_aveflux = []

com = 'rm RMSEs.txt data.txt'
system( com )

print 'Reference flux      : ', ncfn_ref_flux, "\n"
print 'Reference tendencyx : ', ncfn_ref_tend, "\n"
for i in 0..(a_ncfn_list.size/2-1)
  ncfn_flux = a_ncfn_list[i*2  ]
  ncfn_tend = a_ncfn_list[i*2+1]
  print 'File #', i.to_s, "\n"
  print '  Flux     : ', ncfn_flux, "\n"
  print '  Tendency : ', ncfn_tend, "\n"

  com = 'cat ' + rmse_script_template +
        '| sed -e s#FILEFLUX#'    + ncfn_flux     + '#g' +
        '| sed -e s#FILETEND#'    + ncfn_tend     + '#g' +
        '| sed -e s#FILEREFFLUX#' + ncfn_ref_flux + '#g' +
        '| sed -e s#FILEREFTEND#' + ncfn_ref_tend + '#g' +
        '> ' + rmse_script
  system( com )
  com = 'ruby ' + rmse_script + ' 2 | tee | tail -1 > stdout_each.txt'
  print com, "\n"
  system( com )
  file = File.open("stdout_each.txt","r")
  file.each do |line|
    line = line.split
    a_aveflux << line[5]
  end
  file.close
  com = 'rm dcl.pdf stdout_each.txt'
  system( com )
end

File.open("data.txt","w") do |f|
  for i in 0..(a_aveflux.size-1)
    line = i.to_s + " " + a_aveflux[i].to_s + "\n"
    f.puts( line )
  end
end
