require "numru/ggraph"
include NumRu


if ( true ) then
  ncfn_ref  = '../prog11.2_calc_rce_realgas_varvmrtbl_rce_382IPs_75bands/out/profile000500.nc'
  label_ref = '382 IPs (75 bands)'
  a_datalist = [
    '../prog11.2_calc_rce_realgas_varvmrtbl_rce_147IPs/out/profile000500.nc',
    '147 IPs',
    '../prog11.2_calc_rce_realgas_varvmrtbl_rce_118IPs/out/profile000500.nc',
    '118 IPs',
    '../prog11.2_calc_rce_realgas_varvmrtbl_rce_084IPs/out/profile000500.nc',
    ' 84 IPs',
    '../prog11.2_calc_rce_realgas_varvmrtbl_rce_076IPs/out/profile000500.nc',
    ' 76 IPs',
    '../prog11.2_calc_rce_realgas_varvmrtbl_rce_045IPs/out/profile000500.nc',
    ' 45 IPs',
  ]
else
  ncfn_ref  = '../prog11.2_calc_rce_realgas_varvmrtbl_rce_nocld_382IPs_75bands/out/profile000500.nc'
  label_ref = '382 IPs (75 bands)'
  a_datalist = [
    '../prog11.2_calc_rce_realgas_varvmrtbl_rce_nocld_147IPs/out/profile000500.nc',
    '147 IPs',
    '../prog11.2_calc_rce_realgas_varvmrtbl_rce_nocld_118IPs/out/profile000500.nc',
    '118 IPs',
    '../prog11.2_calc_rce_realgas_varvmrtbl_rce_nocld_084IPs/out/profile000500.nc',
    ' 84 IPs',
    '../prog11.2_calc_rce_realgas_varvmrtbl_rce_nocld_076IPs/out/profile000500.nc',
    ' 76 IPs',
    '../prog11.2_calc_rce_realgas_varvmrtbl_rce_nocld_045IPs/out/profile000500.nc',
    ' 45 IPs',
  ]
end


a_ncfn  = []
a_label = []
a_ncfn  << ncfn_ref
a_label << label_ref
for i in 0..(a_datalist.size/2-1)
  a_ncfn  << a_datalist[2*i  ]
  a_label << a_datalist[2*i+1]
end

a_gp = []
for ifile in 0..(a_ncfn.size-1)
  ncfn = a_ncfn[ifile]
  url = ncfn + "@" + "Temp"
  gp = GPhys::IO.open_gturl( url )
  a_gp << gp
end


iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

#DCL.sldiv('y',1,4)
#DCL.sgpset('isub', 96)     # control character of subscription: '_' --> '`'
DCL.sglset('LCNTL', true)
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)            # font size
DCL.sgpset('lclip', true)  # clip graph
#DCL.udlset('LMSG', false)  # flag for message of contour interval
DCL.glpset('lmiss',true)   # missing value

#DCL.sgscmn(4)  # blue-cyan-white-yellow-red
#DCL.sgscmn(5)  # gray-scale
#DCL.sgscmn(14) # blue-white-red

#levels = [110,120,130,140,150,160,170,180,190,200,210,220,230,240]
#patterns = [10999,15999,20999,25999,30999,35999,40999,50999,60999,65999,70999,75999,80999,90999,95999]

minT = 1.0e8
maxT = 0.0
for ifile in 0..(a_gp.size-1)
  gp = a_gp[ifile]
  minT = [minT,gp.min.to_f].min
  maxT = [maxT,gp.max.to_f].max
end
gp = a_gp[0]
pmax = gp.coord('Press').val[0]
pmin = gp.coord('Press').val[-1]

GGraph.set_fig 'itr'=> 2, 'viewport'=>[0.15,0.9,0.1,0.65], 'window'=>[minT*0.95,maxT*1.05,pmax*1.05,pmin*0.95]

flag_first = true
for ifile in 0..(a_gp.size-1)
  gp    = a_gp[ifile]
  label = a_label[ifile]
  GGraph.line gp, flag_first, 'exchange'=>true, 'index'=>((ifile+1)*10+1),
              'legend_vx'=>0.4, 'legend'=>label
  flag_first = false
end

# RMSE
temp_prof_ref = a_gp[0].val # reference
for ifile in (0+1)..(a_gp.size-1)
  temp_prof = a_gp[ifile].val
  rmse = sqrt( ( (temp_prof-temp_prof_ref)**2 ).mean )
  print ifile.to_s.rjust(2), ', ', a_label[ifile], ' : ', rmse, ' K', "\n"
end
gp = a_gp[0]
pmax = gp.coord('Press').val[0]
pmin = gp.coord('Press').val[-1]

DCL.grcls
