#!/usr/bin/bash

ic_path_prefix='../prog01.0_mkprofile_ascii/out/Venus_ProfB_'
ic_path_suffix='.nc'
dir_prefix='prog11.2_calc_rce_realgas_varvmr_'
dir_suffix=''
template_set='template_set'
pid_list='PID_list.txt'

symbols=(
  'H2Omax+COmax+SO2max'
  'H2Omax+COmax+SO2min'
  'H2Omax+COmin+SO2max'
  'H2Omax+COmin+SO2min'
  'H2Omin+COmax+SO2max'
  'H2Omin+COmax+SO2min'
  'H2Omin+COmin+SO2max'
  'H2Omin+COmin+SO2min'
)

if [ -f ${pid_list} ]; then
    rm ${pid_list}
fi

cwd=`pwd`

for sym in "${symbols[@]}" ; do
  echo '----------'
  echo 'SYMBOL:' ${sym}

  dir_name=${dir_prefix}${sym}${dir_suffix}
  dir_path='../'${dir_name}
  rcepro_name='calc_rce_'${sym}

  echo ' '"cp -Rp ${template_set} ${dir_path}"
  cp -Rp ${template_set} ${dir_path}

  echo ' '"cd ${dir_path}"
  cd ${dir_path}

  echo ' '"sed s/SYMBOL/sym/g template_calc_rce.conf > calc_rce.conf"
  sed s/SYMBOL/${sym}/g template_calc_rce.conf > calc_rce.conf

  echo ' '"make >& make.log"
  make >& make.log

  if [ -f calc_rce ]; then
    echo ' '"ln -s calc_rce ${rcepro_name}"
    ln -s calc_rce ${rcepro_name}

    echo ' '"./${rcepro_name} >& error.log &"
    ./${rcepro_name} >& error.log &

    echo ${rcepro_name}':' $! >> ${pid_list}
  else
    echo ' ******************************'
    echo ' ******************************'
    echo ' ******************************'
    echo ' ERROR: calc_rce does not exist.'
    echo ' ******************************'
    echo ' ******************************'
    echo ' ******************************'
  fi

  echo ' '"cd ${cwd}"
  cd ${cwd}
done
