#!/usr/bin/bash

dir_prefix='prog11.2_calc_rce_realgas_varvmrtbl_'
dir_suffix=''
chk_Ts_script='util_chk_Ts.sh'
ts_file='zzz_Ts_time_series'
gp_file='plot_chk.gp'
#
symbols=(
    'rce_382IPs_75bands'
    'rce_147IPs'
    'rce_118IPs'
    'rce_084IPs'
    'rce_076IPs'
    'rce_045IPs'
    'rce_nocld_382IPs_75bands'
    'rce_nocld_147IPs'
    'rce_nocld_118IPs'
    'rce_nocld_084IPs'
    'rce_nocld_076IPs'
    'rce_nocld_045IPs'
)


echo 'set term qt'          >  ${gp_file}
echo 'set key Left reverse' >  ${gp_file}
echo 'plot \'               >> ${gp_file}

ifile=1
for sym in "${symbols[@]}" ; do
  echo '----------'
  echo "SYMBOL ${ifile}: " ${sym}

  dir_name=${dir_prefix}${sym}${dir_suffix}
  dir_path='../'${dir_name}'/out'

  if [ ${ifile} -lt 10 ]; then
      cnum='000'${ifile}
  elif [ ${ifile} -lt 100 ]; then
      cnum='00'${ifile}
  elif [ ${ifile} -lt 1000 ]; then
      cnum='0'${ifile}
  else
      cnum=${ifile}
  fi
  out_file=${ts_file}'_'${cnum}'.txt'
  echo ' '"bash ${chk_Ts_script} ${dir_path} > ${out_file}"
  bash util_chk_Ts.sh ${dir_path} > ${out_file}

#  echo -n '     "'${out_file}'" w l' >> ${gp_file}
#  echo -n '     "'${out_file}'" t "'${sym}'" w l' >> ${gp_file}
  echo -n '     "'${out_file}'" t '"'label${sym}'"' w l' >> ${gp_file}
  if [ ${ifile} -lt ${#symbols[@]} ] ; then
      echo ', \' >> ${gp_file}
  else
      echo       >> ${gp_file}
  fi

  ((ifile = ${ifile} + 1))
done

echo 'replot'   >> ${gp_file}
echo 'pause -1' >> ${gp_file}

gnuplot ${gp_file}

